//
//  GangsaApp.m
//  Gangsa
//

#import "GangsaApp.h"

@implementation GangsaApp

//---------------------------------------------------------------------------------------

// アプリケーション起動完了時の処理
- (void) applicationDidFinishLaunching: (id) sender
{
	LogMethod();
	int	i;
	
	// 乱数の初期化
	srand(time(NULL));
	
	// ステイタス・バーを消す
	[UIHardware _setStatusBarHeight:0.0f];
	[self setStatusBarMode:2 duration:0.0f];
	
	// アプリケーションが利用できる領域を求める
	CGRect appRect = [UIHardware fullScreenApplicationContentRect];
	appRect.origin = CGPointZero;
	
	// ウィンドウを作成
	window = [[UIWindow alloc] initWithContentRect:appRect];
	[window makeKey:self];
	[window orderFront:self];

	// メイン・ビューを作成
	mainView = [[[UIView alloc] initWithFrame:appRect] autorelease];
	[mainView setImage:[UIImage imageNamed:@"Gangsa.jpg"]];
	[mainView setEnabledGestures:YES];
	[window setContentView:mainView];
	
	// 金属片を作成
	NSString *directory = [NSString stringWithString:@"/Applications/Gangsa.app/sounds/"];
	soundSource[0] = [[SoundSource alloc] init];
	[soundSource[0] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"Hit-0a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Hit-0b.aif"]];
	[soundSource[0] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"Mute-0a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Mute-0b.aif"]];
	[soundSource[0] setHitArea:CGRectMake(88, 41, 148, 89)];
	[soundSource[0] setMuteArea:CGRectMake(14, 41, 293, 89)];

	muteIndicator[0] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[0] setOrigin:CGPointMake(255, 76)];
	[muteIndicator[0] setEnabled:NO];
	[muteIndicator[0] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[0]];
	
	soundSource[1] = [[SoundSource alloc] init];
	[soundSource[1] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"Hit-1a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Hit-1b.aif"]];
	[soundSource[1] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"Mute-1a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Mute-1b.aif"]];
	[soundSource[1] setHitArea:CGRectMake(91, 131, 133, 79)];
	[soundSource[1] setMuteArea:CGRectMake(14, 131, 288, 79)];
	  
	muteIndicator[1] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[1] setOrigin:CGPointMake(250, 163)];
	[muteIndicator[1] setEnabled:NO];
	[muteIndicator[1] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[1]];

	soundSource[2] = [[SoundSource alloc] init];
	[soundSource[2] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"Hit-2a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Hit-2b.aif"]];
	[soundSource[2] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"Mute-2a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Mute-2b.aif"]];
	[soundSource[2] setHitArea:CGRectMake(89, 211, 132, 73)];
	[soundSource[2] setMuteArea:CGRectMake(20, 211, 274, 73)];
	
	muteIndicator[2] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[2] setOrigin:CGPointMake(245, 238)];
	[muteIndicator[2] setEnabled:NO];
	[muteIndicator[2] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[2]];
	
	soundSource[3] = [[SoundSource alloc] init];
	[soundSource[3] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"Hit-3a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Hit-3b.aif"]];
	[soundSource[3] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"Mute-3a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Mute-3b.aif"]];
	[soundSource[3] setHitArea:CGRectMake(90, 285, 128, 76)];
	[soundSource[3] setMuteArea:CGRectMake(20, 285, 267, 76)];
	
	muteIndicator[3] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[3] setOrigin:CGPointMake(239, 318)];
	[muteIndicator[3] setEnabled:NO];
	[muteIndicator[3] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[3]];
	
	soundSource[4] = [[SoundSource alloc] init];
	[soundSource[4] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"Hit-4a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Hit-4b.aif"]];
	[soundSource[4] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"Mute-4a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"Mute-4b.aif"]];
	[soundSource[4] setHitArea:CGRectMake(92, 362, 124, 74)];
	[soundSource[4] setMuteArea:CGRectMake(20, 362, 260, 74)];
	 
	muteIndicator[4] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[4] setOrigin:CGPointMake(236, 391)];
	[muteIndicator[4] setEnabled:NO];
	[muteIndicator[4] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[4]];

	// 木片側を作成〜HitとMuteの違いはナシ
	soundSource[5] = [[SoundSource alloc] init];
	[soundSource[5] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-0a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-0b.aif"]];
	[soundSource[5] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-0a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-0a.aif"]];
	[soundSource[5] setHitArea:CGRectMake(55, 0, 208, 40)];
	[soundSource[5] setMuteArea:CGRectMake(55, 0, 208, 40)];
	
	muteIndicator[5] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[5] setOrigin:CGPointMake(0, 0)];
	[muteIndicator[5] setEnabled:NO];
	[muteIndicator[5] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[5]];
	
	soundSource[6] = [[SoundSource alloc] init];
	[soundSource[6] setHitSound:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-1a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-1b.aif"]];
	[soundSource[6] setMuteSound:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-1a.aif"] and:[NSString stringWithFormat:@"%@%@", directory, @"SideHit-1b.aif"]];
	[soundSource[6] setHitArea:CGRectMake(50, 437, 204, 49)];
	[soundSource[6] setMuteArea:CGRectMake(50, 437, 204, 49)];
	
	muteIndicator[6] = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"MuteIndicator.png"]] autorelease];
	[muteIndicator[6] setOrigin:CGPointMake(0, 0)];
	[muteIndicator[6] setEnabled:NO];
	[muteIndicator[6] setAlpha:0.0f];
	[mainView addSubview:muteIndicator[6]];
	
	// インフォ・ビューを作成
	infoView = [[[UIImageView alloc] initWithImage:[UIImage imageNamed:@"Info.png"]] autorelease];
	[infoView setOrigin:CGPointMake(0, 0)];
	[infoView setEnabled:NO];
	[infoView setAlpha:0.0f];
	[mainView addSubview:infoView];
	isInfoShown = NO;
	
	// インフォ・ボタンを作成
	UIPushButton *infoButton = [[[UIPushButton alloc] initWithFrame:CGRectMake(0, 440, 40, 40)] autorelease];
	[infoButton setImage:[UIImage imageNamed:@"infoButton-0.png"] forState:0];
	[infoButton setImage:[UIImage imageNamed:@"infoButton-1.png"] forState:1];
	[infoButton addTarget:self action: @selector(infoButtonPressed:) forEvents: kUIControlEventMouseUp];
	[mainView addSubview:infoButton];

}

// アプリケーション終了時の処理
- (void)applicationWillTerminate
{
	LogMethod();

	// オブジェクトの解放
	[window release];
	
	// ステイタス・バーを表示する　不要？
	[UIHardware _setStatusBarHeight:20.0f];
	[self setStatusBarMode:0 duration:0.0f];
}

//---------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------

// インフォ・ボタンが押された時の処理
- (void) infoButtonPressed:(id)sender
{
	LogMethod();
	
	if (isInfoShown)
		[infoView setAlpha:0.0f];
	else
		[infoView setAlpha:1.0f];

	isInfoShown = !isInfoShown;
}

//---------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------

- (void)scanFingers:(GSEvent *)event
{
	if (event->mouseEvent == 2)	return;	// マウスドラッグ？は無視する
	
	int	i, j;
	CGPoint	point;
	for(i=0; i<kSoundSourceMax; i++)
	{
		for(j=0; j<event->numPoints; j++)
		{
			point = CGPointMake(event->points[j].x, event->points[j].y);
			if ([soundSource[i] isInHitArea:point])
			{
				switch (event->points[j].status)
				{
					case 3:	// mouseDown or mouseStillDown
						[soundSource[i] playSound];
						[soundSource[i] setHitLocked:YES];
						break;
						
					case 0:	// mouseUp
					case 1:	// mouseUp
						[soundSource[i] setHitLocked:NO];
						break;
				}
			}
			else
			if ([soundSource[i] isInMuteArea:point])
			{
				switch (event->points[j].status)
				{
					case 3:	// mouseDown or mouseStillDown
						if (point.x < 160)
							[soundSource[i] setMuted:YES];
						else
							[soundSource[i] toggleMuted];
						[soundSource[i] setMuteLocked:YES];
						break;
						
					case 0:	// mouseUp
					case 1:	// mouseUp
						[soundSource[i] setMuteLocked:NO];
						if (point.x < 160)
							[soundSource[i] setMuted:NO];
						break;
				}
				if ([soundSource[i] isMuted])
					[muteIndicator[i] setAlpha:1.0f];
				else
					[muteIndicator[i] setAlpha:0.0f];
			}
		}
	}
}

- (void)dumpEvent:(GSEvent *)event
{
	if (event->mouseEvent == 2)	return;	// マウスドラッグ？は無視する

	NSLog(@"MouseEvent: %d, fingerCount: %hd, numPoints: %hhd, pos: %f, %f", event->mouseEvent, event->fingerCount, event->numPoints, event->x, event->y);
	int i;
	for (i = 0; i < event->numPoints; i++)
	{
		NSLog(@"  Point %d: %f, %f %d %d %d %d", i + 1, event->points[i].x, event->points[i].y, 
			  (int)event->points[i].status, -99/*(int)event->points[i].slot*/,
			  (int)event->points[i].unk1, (int)event->points[i].unk2);
	}
}

- (void)gestureStarted:(GSEvent *)event
{
	[self dumpEvent:event];
	[self scanFingers:event];
}

- (void)gestureChanged:(GSEvent *)event
{
	[self dumpEvent:event];
	[self scanFingers:event];
}

- (void)gestureEnded:(GSEvent *)event
{
	[self dumpEvent:event];
	[self scanFingers:event];
}

- (void)mouseDown:(GSEvent *)event
{
	[self dumpEvent:event];
	[self scanFingers:event];
}

- (void)mouseDragged:(GSEvent *)event
{
	[self dumpEvent:event];
	[self scanFingers:event];
}

- (void)mouseUp:(GSEvent *)event
{
	[self dumpEvent:event];
	[self scanFingers:event];
}

//---------------------------------------------------------------------------------------

@end

