//
//  SoundSource.h
//  Gangsa
//

#import "common.h"

#define	kSoundVariation	2

@interface SoundSource : NSObject
{
	NSString	*directory;
	NSString	*hitSound[kSoundVariation];
	NSString	*muteSound[kSoundVariation];
	CGRect		hitArea;
	CGRect		muteArea;
	BOOL		isHitLocked;
	BOOL		isMuteLocked;
	BOOL		isMuted;
	int			playingHitIndex;
	int			playingMuteIndex;
}

- (SoundSource *)init;
- (void)dealloc;

- (void)setHitSound:(NSString *)sound0 and:(NSString *)sound1;
- (void)setMuteSound:(NSString *)sound0 and:(NSString *)sound1;
- (void)setHitArea:(CGRect)rect;
- (void)setMuteArea:(CGRect)rect;
- (BOOL)isInHitArea:(CGPoint)point;
- (BOOL)isInMuteArea:(CGPoint)point;

- (void)playSound;
- (void)setHitLocked:(BOOL)onoff;

- (void)toggleMuted;
- (void)setMuted:(BOOL)onoff;
- (void)setMuteLocked:(BOOL)onoff;
- (BOOL)isMuted;

@end
