//
//  SoundSource.m
//  Gangsa
//

#import "SoundSource.h"

@implementation SoundSource

//---------------------------------------------------------------------------------------

- (SoundSource *)init
{
	isHitLocked = NO;
	isMuted = NO;
	return	self;
}

- (void)dealloc
{
	[super dealloc];
}
- (void)setHitSound:(NSString *)sound0 and:(NSString *)sound1
{
	hitSound[0] = [sound0 retain];
	hitSound[1] = [sound1 retain];
}

- (void)setMuteSound:(NSString *)sound0 and:(NSString *)sound1
{
	muteSound[0] = [sound0 retain];
	muteSound[1] = [sound1 retain];
}

- (void)setHitArea:(CGRect)rect
{
	hitArea = rect;
}

- (void)setMuteArea:(CGRect)rect
{
	muteArea = rect;
}

- (BOOL)isInHitArea:(CGPoint)point
{
	return CGRectContainsPoint(hitArea, point);
}

- (BOOL)isInMuteArea:(CGPoint)point
{
	return CGRectContainsPoint(muteArea, point);
}

//---------------------------------------------------------------------------------------

- (void)playSound
{
	if (!isHitLocked)
	{
		if (isMuted)
		{
			playingMuteIndex = rand() % 2;
			GSEventPlaySoundAtPath(muteSound[playingMuteIndex]);
		}
		else
		{
			playingHitIndex = rand() % 2;
			GSEventPlaySoundAtPath(hitSound[playingHitIndex]);
		}
	}
}

- (void)setHitLocked:(BOOL)onoff
{
	isHitLocked = onoff;
}

//---------------------------------------------------------------------------------------

- (void)toggleMuted
{
	if (!isMuteLocked)
	{
		isMuted = !isMuted;
		[self setMuted:isMuted];
	}
}

- (void)setMuted:(BOOL)onoff
{
	isMuted = onoff;
	if (isMuted)
		GSEventStopSoundAtPath(hitSound[playingHitIndex]); // <- It dose not work on 1.1.1.
}

- (void)setMuteLocked:(BOOL)onoff
{
	isMuteLocked = onoff;
}

- (BOOL)isMuted
{
	return isMuted;
}

//---------------------------------------------------------------------------------------


@end
