//
//  common.h
//  by Masayuki Akamatsu
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

//From Aaron hillegass
#define LogMethod() NSLog(@"-[%@ %s]", self, _cmd)

typedef enum {
	kUIControlEventMouseDown = 1 << 0,
	kUIControlEventMouseMovedInside = 1 << 2,
	kUIControlEventMouseMovedOutside = 1 << 3,
	kUIControlEventMouseUpInside = 1 << 6,
	kUIControlEventMouseUpOutside = 1 << 7,
	kUIControlEventMouseMoved = (kUIControlEventMouseMovedInside | kUIControlEventMouseMovedOutside),
	kUIControlEventMouseUp = (kUIControlEventMouseUpInside | kUIControlEventMouseUpOutside),
	kUIControlAllEvents = (kUIControlEventMouseDown | kUIControlEventMouseMovedInside | kUIControlEventMouseMovedOutside | kUIControlEventMouseUpInside | kUIControlEventMouseUpOutside)
} UIControlEventMasks;

typedef enum
{
	UITransitionImmediate = 0,
	UITransitionShiftLeft = 1,
	UITransitionShiftRight = 2,
	UITransitionShiftUp = 3,
	UITransitionFade = 6,
	UITransitionShiftDown = 7,
	UITransitionCoverUp = 8,
	UITransitionCoverDown = 9,
	// Customized transition style 
 	UITransitionFlip = 100, 
 	UITransitionFlipLeft = 101, 
 	UITransitionFlipRight = 102, 
 	UITransitionZoomIn = 103, 
 	UITransitionZoomOut = 104 
} UITransitionStyle;

typedef enum {
	kGSFontTraitRegular = 0,
    kGSFontTraitItalic = 1,
    kGSFontTraitBold = 2,
    kGSFontTraitBoldItalic = (kGSFontTraitBold | kGSFontTraitItalic)
} GSFontTrait;